#if 0
#  This is a C/MPW script hybrid!
# Just execute this on the command line, as is - Really!

Unset 1 ; (Evaluate "{0}"=~/()1./)  dev:null ; Set Targ "{1}"
Unset 2 ; (Evaluate "{0}"=~/()2:/)  dev:null
If NOT `Exists "{2}"::Obj:macintosh_cseries.a.o`
  Echo '# Warning: :Obj:macintosh_cseries.a.o does not already exist.' ; Echo '# Attempting to "Make" it...'
  Begin ; Make :Obj:macintosh_cseries.a.o ; End > "{2}":macintosh_cseries.c.o.makeout
  "{2}":macintosh_cseries.c.o.makeout
  Delete "{2}":macintosh_cseries.c.o.makeout
End
SC "{0}" -o "{0}".o -i :: -sym off -mc68881 -mc68040 -b2 -proto strict
ILink -o "{Targ}" "{2}"::Obj:macintosh_cseries.a.o "{0}".o -mf -t 'MPST' -c 'MPS ' -model far 
  "{Libraries}"MacRuntime.o "{CLibraries}"StdCLib.o 
  "{Libraries}"Interface.o "{Libraries}"IntEnv.o 
  -sn STDCLIB=Main -sn STDIO=Main -sn INTENV=Main -sn %A5Init=Main -sn SADEV=Main 
  -sn SANELIB=Main -state nouse -compact -pad 0
Files "{Targ} " ; Exit 0
#endif
/*
 prime.c
  the source file for the "prime" tool

  My computer ise so old, it took over an hour to run this line:
    `prime 10101234567890123467`

  For MyCSeries version 0.3

  Created: March 3, 2006
  Revised: November 24, 2006

 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <ConditionalMacros.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <signal.h>

/* constants */

#define MAXIMUM_FACTORS			64

/* macros n sh** */

#define commandPeriod()			    (*((volatile char*)0x179)&*((volatile char*)0x17A))

extern void Debugger(void) = {0xA9FF};

typedef unsigned long			UInt32;

#if TYPE_LONGLONG
  typedef unsigned long long       UInt64;

/* copied from stdlib.h, cs_math.h and cseries.h to reduce compilation time */

# define Int64Lo(x)                 ((UInt32)(x))
#else
# ifndef __MACTYPES__
   typedef struct UnsignedWide
   {
      UInt32        hi, lo;
   } UInt64;
# endif

# define Int64Lo(x)                 (x).lo
#endif

UInt32 __sqrtu64(UInt64 n);

UInt64 __strtoull(const char *nptr, char **endptr, int base);

#pragma parameter __D2 _UDiv64U32R(__A0,__D2)
 extern UInt32 _UDiv64U32R( UInt64*, UInt32 ) =
   {0x2018, 0x2210, 0x2082, 0x4C50, 2, 0x4C50, 0x1402, 0x2081, 0x2100};
#pragma parameter __D0 _UMod32(__A0,__D2)
 extern UInt32 _UMod32( UInt64*, UInt32 ) =
   {0x2018, 0x2210, 0xB480, 0x620A, 0x2041, 0x4C42, 1, 0x2001, 0x2208, 0x4C42,
    0x1400};

#  define U64LeU32(x,y)             ((x).lo<=(y) && !(x).hi)

/* globals */

static unsigned char	short_prime[] = {0, 0, 1, 1, 0, 1, 0, 1, 0, 0};

static volatile char	stop = 0;

static UInt32		factors[MAXIMUM_FACTORS+1] = {0};

/* private prototypes */

static int parsefactors(const char **a, UInt32 *f, int i, UInt32 *r);

static void interrupt(int);

/* code */

int main(int argc, char **argv)
{
	char			**a = argv;
	UInt32			d = 3;

	if (argc<0)
		return 0;

	if (--argc==0)
		goto help;

	signal(SIGINT,interrupt);

	do
	{
		if (strcmp(*++a,"-h")==0)
			goto help;

		if (strcmp(*a,"-t")==0)
		{
			UInt32		*s, c, i, n, e, t;

			if ((e=parsefactors(a,factors,argc,&d))==0)
				return 1;

			d *= factors[0];
			for(n=3,t=3,c=-1; n<d; ++n)
			{
				s = factors; i = e;
				do
				{
					if ((n%*s++)==0)
						break;
				} while(--i);
				if (i!=0) continue;

				fprintf(stdout,(++c&15)!=0 ? "%d, " : "\n\t%d, ", n-t);
				if (stop|=commandPeriod())
					goto abort;

				t = n;
			}
			return 0;
		}
		if (strcmp(*a,"-k")==0)
		{
			UInt32		*s, i, n, c, e;

			if ((e=parsefactors(a,factors,argc,&d))==0)
				return 1;

			fputs("\n\t0x",stdout);
			for(n=0,c=1; n<d; ++n)
			{
				c <<= 1; s = factors; i = e;
				do
				{
					if ((n%*s++)==0)
						goto nope;
				} while(--i);
				++c;
			nope:
				if (c>=0x100)
				{
					fprintf(stdout,"%02X", c&255);
					/*if (n!=d-1)
					{*/
//						fprintf(stdout,"# %d", n);
						if ((n&0x38)!=0x38)
							fputs(", 0x", stdout);
						else
							fputs("\n\t0x", stdout);
					/*}*/
					if (stop|=commandPeriod())
						break;
					c = 1;
				}
			}
			if (c<0x100)
			{
				while(c<0x100) c <<= 1;
				fprintf(stdout,"%02X", c&255);
			}
			if (stop)
			{
			abort:
				fprintf(stderr,"\n### %s - User aborted.\n", argv[0]);
				return 1;
			}
			return 0;
		}

/*if (strcmp(*argv,"-p")==0)*/
		if (isdigit(**a))
		{
			UInt64			n, t;
			UInt32			e;

			n = __strtoull(*a,NULL,10);

			if (U64LeU32(n,9))
			{
				fputc(short_prime[Int64Lo(n)]+'0',stdout);
				return 0;
			}
			if ((Int64Lo(n)&1)==0)
				goto no;
			e = __sqrtu64(n);

			while(d<=e)
			{
				t = n;
/*if (_UDiv64U32R(&t,d)==0) goto no;*/
				if (_UMod32(&t,d)==0)
					goto no;
				if ((d+=4)>e)
					break;
				t = n;
				if (_UMod32(&t,d)==0)
					goto no;
				if ((d+=2)>e)
					break;
				t = n;
				if (_UMod32(&t,d)==0)
					goto no;
				if ((d+=2)>e)
					break;
				t = n;
				if (_UMod32(&t,d)==0)
					{no: fputc('0',stdout); return 0;}
				d += 2;

				if (stop|=commandPeriod())
					{fprintf(stderr,"### %s - User aborted during test.\n", argv[0]); exit(1);}
			}
			fputc('1',stdout);
			return 0;
		} else if ((*a)[0]=='-' && isdigit((*a)[1]))
		{
			fprintf(stderr,"### %s - Prime test requires a positive integer.\n", argv[0]);
			return 1;
		} else
		{
			fprintf(stderr,"### %s - Unrecognized option or parameter '%s'.\n", argv[0],*a);
			return 1;
		}
	} while(--argc);

help:
	fputs(
"#  prime [options...] [parameters] >output\n"
"#\n"
"#   -h          display this help info (or run tool with no arguments)\n"
"#   -t          generate a factor table; returns binary table in hex\n"
"#   -k          generate a skipping table (eg.: {2} for skipping even numbers)\n"
"#\n"
"#  Pass a positive integer to calculate whether a value is prime\n"
"#\n"
"# Note that all operations are limited to 32 bit factors, and therefore\n"
"#  limited to 63 bits in precision.\n",stdout);
	return 1;
}

static int parsefactors(const char **a, UInt32 *f, int i, UInt32 *r)
{
	UInt32			*s, e, d;

	if (--i==0)
		{fputs("# Error: prime skip generation requires prime factors\n",stderr); return 0;}

	s = f; e = 0;
	do
	{
		if (++e>MAXIMUM_FACTORS)
			{fputs("# Error: too many prime factors\n",stderr); return 0;}

		if (*(*++a)=='-')
			break;
		*s++ = atoi(*a);
	} while(--i!=0);

	s = f; i = e, d = 1;
	do d *= *s++; while(--i);

	if (d<2)
		{fputs("# Error: calculated product is less than two\n",stderr); return 0;}

	if (r!=(UInt32*)NULL)
		*r = d;

	return e;
}

static void interrupt(int n)
{
#pragma unused(n)
	stop = 1;
}
